SystemOrganization addCategory: #'WebStone-Seaside'!

WARequestHandler subclass: #WSRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStone-Seaside'!

WSRenderer subclass: #WSHtmlRenderer
	instanceVariableNames: 'content'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStone-Seaside'!

!WSHtmlRenderer class methodsFor: 'registering' stamp: 'pmm 7/25/2012 19:21'!
register
	| latin1 unicode |
	WAAdmin register: (self new content: 'ascii'; yourself) at: 'webstone/html/ascii'.
	WAAdmin register: (self new content: 'as<ii'; yourself) at: 'webstone/html/escape'.
	latin1 := String streamContents: [ :stream |
		#(228 115 99 105 105) do: [ :each |
			stream nextPut: (Character value: each) ] ].
	WAAdmin register: (self new content: latin1; yourself) at: 'webstone/html/latin1'.
	unicode := (String with: (Character value: 16r20AC)), 'uro'.
	WAAdmin register: (self new content: unicode; yourself) at: 'webstone/html/unicode'! !

!WSHtmlRenderer methodsFor: 'accessing' stamp: 'pmm 7/21/2012 23:33'!
content: aString
	content := aString! !

!WSHtmlRenderer methodsFor: 'private' stamp: 'pmm 7/21/2012 23:57'!
contentType
	^ WAMimeType textHtml
		charset: self requestContext charSet;
		yourself! !

!WSHtmlRenderer methodsFor: 'private' stamp: 'pmm 7/21/2012 23:42'!
documentClass
	^ WAHtmlDocument! !

!WSHtmlRenderer methodsFor: 'private' stamp: 'pmm 7/21/2012 23:44'!
new
	^ self! !

!WSHtmlRenderer methodsFor: 'rendering' stamp: 'pmm 7/21/2012 23:52'!
renderOn: html
	10 timesRepeat: [
		html div: [
			10 timesRepeat: [
				html unorderedList: [
					10 timesRepeat: [
						html listItem: content ] ] ] ] ]! !

!WSHtmlRenderer methodsFor: 'private' stamp: 'pmm 7/21/2012 23:42'!
rendererClass
	^ WAHtmlCanvas! !

!WSHtmlRenderer methodsFor: 'private' stamp: 'pmm 7/21/2012 23:42'!
rootClass
	^ WAHtmlRoot! !

!WSHtmlRenderer methodsFor: 'rendering' stamp: 'pmm 7/21/2012 23:56'!
updateRoot: aRoot
	aRoot beHtml5.
	aRoot meta contentType: self contentType! !

WSRenderer subclass: #WSJsonRenderer
	instanceVariableNames: 'content'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStone-Seaside'!

!WSJsonRenderer class methodsFor: 'registering' stamp: 'pmm 7/25/2012 19:21'!
register
	| latin1 unicode |
	WAAdmin register: (self new content: 'ascii'; yourself) at: 'webstone/json/ascii'.
	WAAdmin register: (self new content: 'as"ii'; yourself) at: 'webstone/json/escape'.
	latin1 := String streamContents: [ :stream |
		#(228 115 99 105 105) do: [ :each |
			stream nextPut: (Character value: each) ] ].
	WAAdmin register: (self new content: latin1; yourself) at: 'webstone/json/latin1'.
	unicode := (String with: (Character value: 16r20AC)), 'uro'.
	WAAdmin register: (self new content: unicode; yourself) at: 'webstone/json/unicode'! !

!WSJsonRenderer methodsFor: 'accessing' stamp: 'pmm 7/25/2012 19:07'!
content: aString
	content := aString! !

!WSJsonRenderer methodsFor: 'private' stamp: 'pmm 7/25/2012 19:04'!
contentType
	^ WAMimeType applicationJson
		charset: self requestContext charSet;
		yourself! !

!WSJsonRenderer methodsFor: 'private' stamp: 'pmm 7/25/2012 19:04'!
documentClass
	^ WAJsonDocument! !

!WSJsonRenderer methodsFor: 'rendering' stamp: 'pmm 7/25/2012 19:17'!
jsonOn: json
	json array: [
		10 timesRepeat: [
			json value: [
				json array: [
					10 timesRepeat: [
						json value: [ 
							json object: [
								1 to: 10 do: [ :index |
									json key: index value: content ] ] ] ] ] ] ] ]! !

!WSJsonRenderer methodsFor: 'private' stamp: 'pmm 7/25/2012 19:05'!
new
	^ self! !

!WSJsonRenderer methodsFor: 'private' stamp: 'pmm 7/25/2012 19:05'!
rendererClass
	^ WAJsonCanvas! !

!WSJsonRenderer methodsFor: 'private' stamp: 'pmm 7/25/2012 19:06'!
rootClass
	^ WARoot! !

!WSJsonRenderer methodsFor: 'rendering' stamp: 'pmm 7/25/2012 19:06'!
updateRoot: aRoot! !

!WSRenderer methodsFor: 'private' stamp: 'pmm 7/21/2012 23:22'!
contentType
	self subclassResponsibility! !

!WSRenderer methodsFor: 'private' stamp: 'pmm 7/21/2012 23:23'!
documentClass
	self subclassResponsibility! !

!WSRenderer methodsFor: 'handling' stamp: 'pmm 7/21/2012 23:47'!
handleFiltered: aRequestContext
	self renderContext: aRequestContext! !

!WSRenderer methodsFor: 'rendering' stamp: 'pmm 7/21/2012 23:53'!
renderContext: aRequestContext
	aRequestContext respond: [ :response |
		| context document renderer documentRoot |
		response contentType: self contentType.
		document := self documentClass
			on: response stream
			codec: aRequestContext codec.
		context := WARenderContext new.
		context document: document.
		renderer := self rendererClass context: context.
		
		documentRoot := self rootClass context: context.
		self updateRoot: documentRoot.
		document open: documentRoot.
		renderer render: self; flush.
		document close ]! !

!WSRenderer methodsFor: 'private' stamp: 'pmm 7/21/2012 23:25'!
rendererClass
	self subclassResponsibility! !

!WSRenderer methodsFor: 'private' stamp: 'pmm 7/21/2012 23:26'!
rootClass
	self subclassResponsibility! !

!WSRenderer methodsFor: 'rendering' stamp: 'pmm 7/21/2012 23:51'!
updateRoot: aRoot! !
